<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ProductController.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">vendingmachine</a> &gt; <a href="index.source.html" class="el_package">com.example.vendingmachine.controller</a> &gt; <span class="el_source">ProductController.java</span></div><h1>ProductController.java</h1><pre class="source lang-java linenums">package com.example.vendingmachine.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import com.example.vendingmachine.entity.Product;
import com.example.vendingmachine.service.ProductService;
import com.example.vendingmachine.service.ServiceStatus;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotEmpty;
import lombok.extern.slf4j.Slf4j;

@RestController
<span class="fc" id="L25">@Slf4j</span>
<span class="fc" id="L26">public class ProductController {</span>

    @Autowired
    ProductService productService;

    @PostMapping(&quot;/products&quot;)
    @Operation(summary = &quot;add product to the vending machine&quot;, description = &quot;Id, name and price are mandatory&quot;)
    @ApiResponses(value = {
            @ApiResponse(responseCode = &quot;200&quot;, description = &quot;Product was added&quot;),
            @ApiResponse(responseCode = &quot;422&quot;, description = &quot;There is already product with the same id / The vending machine can store 10 product as maximum&quot;)
    })
    public ResponseEntity&lt;String&gt; addProduct(@Valid @RequestBody Product product) {
<span class="fc" id="L38">        log.info(&quot;addProduct:&quot; + product.toString());</span>
<span class="fc" id="L39">        ServiceStatus serviceStatus = productService.addProduct(product);</span>
<span class="fc" id="L40">        ResponseEntity&lt;String&gt; responseEntity = null;</span>
<span class="pc bpc" id="L41" title="1 of 4 branches missed.">        switch (serviceStatus) {</span>
            case SUCCESSFUL:
<span class="fc" id="L43">                responseEntity = ResponseEntity.status(HttpStatus.OK)</span>
<span class="fc" id="L44">                        .body(&quot;Product was added&quot;);</span>
<span class="fc" id="L45">                break;</span>
            case ENTITY_ALREADY_EXIST:
<span class="fc" id="L47">                responseEntity = ResponseEntity.status(HttpStatus.UNPROCESSABLE_ENTITY)</span>
<span class="fc" id="L48">                        .body(&quot;There is already product with the same id&quot;);</span>
<span class="fc" id="L49">                break;</span>
            case ENTITY_COLLECTION_MAX_SIZE_LIMIT:
<span class="fc" id="L51">                responseEntity = ResponseEntity.status(HttpStatus.UNPROCESSABLE_ENTITY)</span>
<span class="fc" id="L52">                        .body(&quot;The vending machine can store 10 product as maximum&quot;);</span>
<span class="fc" id="L53">                break;</span>
            default:
                break;
        }
<span class="fc" id="L57">        return responseEntity;</span>
    }

    @PutMapping(&quot;/products&quot;)
    @Operation(summary = &quot;update product to the vending machine&quot;, description = &quot;Id, name and price are mandatory&quot;)
    @ApiResponses(value = {
            @ApiResponse(responseCode = &quot;200&quot;, description = &quot;Product is updated&quot;),
            @ApiResponse(responseCode = &quot;422&quot;, description = &quot;There is product with the specified id, but cannot be added since vending machine can store 10 product as maximum&quot;)
    })
    public ResponseEntity&lt;String&gt; updateProduct(@Valid @RequestBody Product product) {
<span class="fc" id="L67">        log.info(&quot;updateProduct:&quot; + product.toString());</span>
<span class="fc" id="L68">        ServiceStatus serviceStatus = productService.updateProduct(product);</span>
<span class="fc" id="L69">        ResponseEntity&lt;String&gt; responseEntity = null;</span>
<span class="pc bpc" id="L70" title="1 of 3 branches missed.">        switch (serviceStatus) {</span>
            case SUCCESSFUL:
<span class="fc" id="L72">                responseEntity = ResponseEntity.status(HttpStatus.OK).body(&quot;Product is updated&quot;);</span>
<span class="fc" id="L73">                break;</span>
            case ENTITY_COLLECTION_MAX_SIZE_LIMIT:
<span class="fc" id="L75">                responseEntity = ResponseEntity.status(HttpStatus.UNPROCESSABLE_ENTITY)</span>
<span class="fc" id="L76">                        .body(&quot;There is product with the specified id, but cannot be added since vending machine can store 10 product as maximum&quot;);</span>
<span class="fc" id="L77">                break;</span>
            default:
                break;
        }
<span class="fc" id="L81">        return responseEntity;</span>
    }

    @DeleteMapping(&quot;/products/{id}&quot;)
    @Operation(summary = &quot;delete product to the vending machine&quot;, description = &quot;Id is mandatory&quot;)
    @ApiResponses(value = {
            @ApiResponse(responseCode = &quot;200&quot;, description = &quot;Product was deleted&quot;),
            @ApiResponse(responseCode = &quot;400&quot;, description = &quot;Product id was not found&quot;)
    })
    public ResponseEntity&lt;String&gt; deleteProductById(@Valid @NotEmpty @PathVariable long id) {
<span class="fc" id="L91">        ServiceStatus serviceStatus = productService.deleteProductById(id);</span>
<span class="fc bfc" id="L92" title="All 2 branches covered.">        if (serviceStatus == ServiceStatus.SUCCESSFUL) {</span>
<span class="fc" id="L93">            return ResponseEntity.status(HttpStatus.OK).body(&quot;Product was deleted&quot;);</span>
        } else {
<span class="fc" id="L95">            return ResponseEntity.status(HttpStatus.BAD_REQUEST).body(&quot;Product id was not found&quot;);</span>
        }
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>